'
' XGA_DEMO2 - graphics demo diagnostic for Morpheus XGA driver v0.80
'
' Copyright 2009 William Henning
'
' http://Mikronauts.com
'
' mikronauts@gmail.com
'
' LICENSE
'
' The Morpheus drivers (xmm*,xga*,vga* and others) are licensed for distribution in one of two ways:
'
' GPL v2.0 - which means that you must also distribute the source code to your application under the GPL
'
' Here is a link to the terms of the GPL v2.0: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
'
' -or-
'
' If you don't want to distribute your source code you can contact me for a commercial license - this means
' that you will have to pay a reasonable licensing fee if you do not wish to freely release your source code.
'
' I will gladly accept improvements to the drivers, however I ask that I can dual license the improved drivers
' as detailed above, and of course I will give you credit in the source and documentation for any of your
' improvements that I use.
'
' Please Note: You may not remove or modify these terms from any of the files or documentation.
'
' CREDITS:
'
' Chip Gracey for the Propeller and multi-cog video synchronization example code
'
' ariba, jazzed, PhiPi and lonesock from the forums for a great fast way of building longs from 8 bit inputs
' see the original thread at http://forums.parallax.com/forums/default.aspx?f=25&p=1&m=349679
'
' Hanno for making ViewPort that helped me debug Morpheus
'
'  

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  MAXX = 1023
  MAXY = 767

OBJ

     gr: "xmm_gpu"

VAR
  long  seed
  byte set[256]

PUB main | i
  seed:= cnt

  gr.config($200000,1024,768,2)
  gr.start

  repeat i from 0 to 255
    set[i]:=i

  repeat
    ColorPalette
    RefreshDemo
    MoireDemo
    RectDemo
    LineDemo
    CircDemo
    BandsDemo

PUB rnd(x)
  return ||((seed?)//x)

PUB ColorPalette|y,p,r,i
  gr.cls(0)
  p:= string("Morpheus 256 Color Palette")
  repeat i from 1 to 3
    gr.pen(i)
    gr.putstr(256*i-120,24*i-12,p)
  repeat y from 0 to 511 step 8
    repeat p from 0 to 3
      gr.pen(p)
      repeat r from 0 to 7
        gr.hline(256*p,y+r+100,256*p+255)
  repeat p from 0 to 511
    i:=(p/8)<<2
    gr.SetPalette(p+100,0,i>>5,(i>>2)&7,i&3)
    i++
    gr.SetPalette(p+100,1,i>>5,(i>>2)&7,i&3)
    i++
    gr.SetPalette(p+100,2,i>>5,(i>>2)&7,i&3)
    i++
    gr.SetPalette(p+100,3,i>>5,(i>>2)&7,i&3)
  gr.waitms(10000)
  gr.FillPalette(0,0,0,0)
  gr.FillPalette(1,0,0,3)
  gr.FillPalette(2,0,7,0)
  gr.FillPalette(3,7,0,0)

PUB RefreshDemo|x,y,ch
  repeat x from 0 to 127
    repeat y from 0 to 767 step 12
      gr.pen((y>>8)+1)
      gr.PutBytes(0,y,@set[x],128)

PUB MoireDemo|c,x,y
  gr.cls(0)
  repeat c from 1 to 3
    gr.pen(c&3)
    repeat x from 0 to MAXX step 3
      gr.line(x,0,MAXX-x,MAXY)
    repeat y from 0 to MAXY step 3
      gr.line(MAXX,y,0,MAXY-y)

PUB RectDemo
  gr.cls(0)
  repeat 500
    gr.pen(rnd(4))
    gr.DrawRect(rnd(MAXX-100),rnd(MAXY-100),rnd(95)+5,rnd(95)+5)
    gr.FilledRect(rnd(MAXX-100),rnd(MAXY-100),rnd(95)+5,rnd(95)+5)

PUB LineDemo
  gr.cls(0)
  repeat 1000
    gr.pen(rnd(4))
    gr.line(rnd(MAXX),rnd(MAXY),rnd(MAXX),rnd(MAXY))

PUB CircDemo|r
  gr.cls(0)
  repeat 250
    gr.pen(rnd(4))
    gr.DrawCircle(rnd(MAXX-200)+100,rnd(MAXY-200)+100,rnd(100))
    gr.FilledCircle(rnd(MAXX-200)+100,rnd(MAXY-200)+100,rnd(100))

PUB BandsDemo|j,k
  gr.cls(0)
  repeat k from 5 to 2
    repeat j from 0 to MAXY
      gr.pen((j>>k)&3)
      gr.hline(0,j,MAXX)

